# coding: utf-8

"""
    全部  API 文档

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CurrencyExchangeRate(BaseModel):
    """
    货币兑换比率实体，用于表示不同货币之间的兑换关系。
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="货币兑换比率的唯一标识符。")
    from_currency_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="兑换的源货币代码，例如 'USD'。", alias="fromCurrencyCode")
    to_currency_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="兑换的目标货币代码，例如 'CNY'。", alias="toCurrencyCode")
    exchange_rate: Optional[StrictInt] = Field(default=None, description="从源货币到目标货币的兑换比率。例如，1 USD = 6.5 CNY。", alias="exchangeRate")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="兑换比率的详细描述信息。")
    create_date: Optional[datetime] = Field(default=None, description="货币兑换比率的创建日期，默认为当前时间。", alias="createDate")
    last_update: Optional[datetime] = Field(default=None, description="货币兑换比率的最后更新日期，默认为当前时间。", alias="lastUpdate")
    __properties: ClassVar[List[str]] = ["id", "fromCurrencyCode", "toCurrencyCode", "exchangeRate", "description", "createDate", "lastUpdate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CurrencyExchangeRate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if from_currency_code (nullable) is None
        # and model_fields_set contains the field
        if self.from_currency_code is None and "from_currency_code" in self.model_fields_set:
            _dict['fromCurrencyCode'] = None

        # set to None if to_currency_code (nullable) is None
        # and model_fields_set contains the field
        if self.to_currency_code is None and "to_currency_code" in self.model_fields_set:
            _dict['toCurrencyCode'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CurrencyExchangeRate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "fromCurrencyCode": obj.get("fromCurrencyCode"),
            "toCurrencyCode": obj.get("toCurrencyCode"),
            "exchangeRate": obj.get("exchangeRate"),
            "description": obj.get("description"),
            "createDate": obj.get("createDate"),
            "lastUpdate": obj.get("lastUpdate")
        })
        return _obj


