# coding: utf-8

"""
    全部  API 文档

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ServiceItem(BaseModel):
    """
    服务配置项实体，用于定义和管理服务相关的配置信息。
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="服务配置项的唯一标识符。")
    biz_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务配置项所属的业务代码，用于分类管理。", alias="bizCode")
    provider_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="关联的服务商代码，用于标识提供该配置项的服务商。", alias="providerCode")
    group_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务配置项所属的功能分组代码，用于组织和管理相关配置项。", alias="groupCode")
    name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="服务配置项的名称，用于描述其功能或用途。")
    code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务配置项的唯一代码，用于系统内部标识。")
    value_type: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务配置项的值类型，例如 'text', 'number', 'boolean' 等。默认为 'text'。", alias="valueType")
    icon: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="服务配置项的图标URL或路径，用于在界面上显示。")
    value_defaults: Optional[StrictStr] = Field(default=None, description="服务配置项的默认值，当未设置具体值时使用。", alias="valueDefaults")
    description: Optional[StrictStr] = Field(default=None, description="服务配置项的详细描述信息，用于说明其用途和配置方法。")
    tags: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="用于分类或标记服务配置项的标签。")
    is_system: Optional[StrictBool] = Field(default=None, description="指示该配置项是否为系统级别的配置项，默认为 false。", alias="isSystem")
    show: Optional[StrictBool] = Field(default=None, description="指示服务配置项是否在界面上显示，默认为 true。")
    show_index: Optional[StrictInt] = Field(default=None, description="服务配置项在界面上的显示顺序。", alias="showIndex")
    create_date: Optional[datetime] = Field(default=None, description="服务配置项的创建日期，默认为当前时间。", alias="createDate")
    last_update: Optional[datetime] = Field(default=None, description="服务配置项的最后更新日期，默认为当前时间。", alias="lastUpdate")
    __properties: ClassVar[List[str]] = ["id", "bizCode", "providerCode", "groupCode", "name", "code", "valueType", "icon", "valueDefaults", "description", "tags", "isSystem", "show", "showIndex", "createDate", "lastUpdate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ServiceItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if biz_code (nullable) is None
        # and model_fields_set contains the field
        if self.biz_code is None and "biz_code" in self.model_fields_set:
            _dict['bizCode'] = None

        # set to None if provider_code (nullable) is None
        # and model_fields_set contains the field
        if self.provider_code is None and "provider_code" in self.model_fields_set:
            _dict['providerCode'] = None

        # set to None if group_code (nullable) is None
        # and model_fields_set contains the field
        if self.group_code is None and "group_code" in self.model_fields_set:
            _dict['groupCode'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if code (nullable) is None
        # and model_fields_set contains the field
        if self.code is None and "code" in self.model_fields_set:
            _dict['code'] = None

        # set to None if value_type (nullable) is None
        # and model_fields_set contains the field
        if self.value_type is None and "value_type" in self.model_fields_set:
            _dict['valueType'] = None

        # set to None if icon (nullable) is None
        # and model_fields_set contains the field
        if self.icon is None and "icon" in self.model_fields_set:
            _dict['icon'] = None

        # set to None if value_defaults (nullable) is None
        # and model_fields_set contains the field
        if self.value_defaults is None and "value_defaults" in self.model_fields_set:
            _dict['valueDefaults'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if tags (nullable) is None
        # and model_fields_set contains the field
        if self.tags is None and "tags" in self.model_fields_set:
            _dict['tags'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ServiceItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "bizCode": obj.get("bizCode"),
            "providerCode": obj.get("providerCode"),
            "groupCode": obj.get("groupCode"),
            "name": obj.get("name"),
            "code": obj.get("code"),
            "valueType": obj.get("valueType"),
            "icon": obj.get("icon"),
            "valueDefaults": obj.get("valueDefaults"),
            "description": obj.get("description"),
            "tags": obj.get("tags"),
            "isSystem": obj.get("isSystem"),
            "show": obj.get("show"),
            "showIndex": obj.get("showIndex"),
            "createDate": obj.get("createDate"),
            "lastUpdate": obj.get("lastUpdate")
        })
        return _obj


