# coding: utf-8

"""
    全部  API 文档

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ServiceProvider(BaseModel):
    """
    服务商实体，用于表示和管理系统中的服务提供方信息。
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="服务商的唯一标识符。")
    biz_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务商的业务代码，用于标识其所属业务领域。", alias="bizCode")
    name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="服务商的名称。")
    code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="服务商的唯一代码，用于系统内部标识。")
    icon: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="服务商图标的URL或路径。")
    description: Optional[StrictStr] = Field(default=None, description="服务商的详细描述信息。")
    tags: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="用于分类或标记服务商的标签。")
    show: Optional[StrictBool] = Field(default=None, description="指示服务商是否在界面上显示。")
    show_index: Optional[StrictInt] = Field(default=None, description="服务商在界面上的显示顺序。", alias="showIndex")
    create_date: Optional[datetime] = Field(default=None, description="服务商记录的创建日期，默认为当前时间。", alias="createDate")
    last_update: Optional[datetime] = Field(default=None, description="服务商记录的最后更新日期，默认为当前时间。", alias="lastUpdate")
    __properties: ClassVar[List[str]] = ["id", "bizCode", "name", "code", "icon", "description", "tags", "show", "showIndex", "createDate", "lastUpdate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ServiceProvider from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if biz_code (nullable) is None
        # and model_fields_set contains the field
        if self.biz_code is None and "biz_code" in self.model_fields_set:
            _dict['bizCode'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if code (nullable) is None
        # and model_fields_set contains the field
        if self.code is None and "code" in self.model_fields_set:
            _dict['code'] = None

        # set to None if icon (nullable) is None
        # and model_fields_set contains the field
        if self.icon is None and "icon" in self.model_fields_set:
            _dict['icon'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if tags (nullable) is None
        # and model_fields_set contains the field
        if self.tags is None and "tags" in self.model_fields_set:
            _dict['tags'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ServiceProvider from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "bizCode": obj.get("bizCode"),
            "name": obj.get("name"),
            "code": obj.get("code"),
            "icon": obj.get("icon"),
            "description": obj.get("description"),
            "tags": obj.get("tags"),
            "show": obj.get("show"),
            "showIndex": obj.get("showIndex"),
            "createDate": obj.get("createDate"),
            "lastUpdate": obj.get("lastUpdate")
        })
        return _obj


