# coding: utf-8

"""
    全部  API 文档

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class UserSetting(BaseModel):
    """
    用户配置实体，用于存储用户的个性化设置。
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="用户的唯一标识符。")
    user_id: StrictInt = Field(description="关联的用户ID，表示该配置属于哪个用户。", alias="userID")
    provider_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="提供商的唯一代码，用于标识服务提供者。", alias="providerCode")
    group_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="组的唯一代码，用于分类设置项。", alias="groupCode")
    code: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="设置项的唯一代码或键名，用于标识具体的配置项。")
    value: Annotated[str, Field(min_length=1, strict=True)] = Field(description="设置项的具体值或选项。")
    tags: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="用于对设置项进行分类或标记的标签。")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="设置项的详细描述，说明其作用或用途。")
    frontend_usable: Optional[StrictBool] = Field(default=None, description="指示该设置项是否在前端界面中可用。", alias="frontendUsable")
    create_date: Optional[datetime] = Field(default=None, description="设置项的创建时间。", alias="createDate")
    last_update: Optional[datetime] = Field(default=None, description="设置项的最后更新时间。", alias="lastUpdate")
    __properties: ClassVar[List[str]] = ["id", "userID", "providerCode", "groupCode", "code", "value", "tags", "description", "frontendUsable", "createDate", "lastUpdate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserSetting from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if provider_code (nullable) is None
        # and model_fields_set contains the field
        if self.provider_code is None and "provider_code" in self.model_fields_set:
            _dict['providerCode'] = None

        # set to None if group_code (nullable) is None
        # and model_fields_set contains the field
        if self.group_code is None and "group_code" in self.model_fields_set:
            _dict['groupCode'] = None

        # set to None if tags (nullable) is None
        # and model_fields_set contains the field
        if self.tags is None and "tags" in self.model_fields_set:
            _dict['tags'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserSetting from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "userID": obj.get("userID"),
            "providerCode": obj.get("providerCode"),
            "groupCode": obj.get("groupCode"),
            "code": obj.get("code"),
            "value": obj.get("value"),
            "tags": obj.get("tags"),
            "description": obj.get("description"),
            "frontendUsable": obj.get("frontendUsable"),
            "createDate": obj.get("createDate"),
            "lastUpdate": obj.get("lastUpdate")
        })
        return _obj


